
METHOD_GNSS  = 1
METHOD_AGNSS = 2

INTERVAL_1S   = 1
INTERVAL_2S   = 2
INTERVAL_5S   = 5
INTERVAL_10S  = 10
INTERVAL_20S  = 20
INTERVAL_30S  = 30
INTERVAL_60S  = 60
INTERVAL_120S = 120
INTERVAL_DEFAULT = INTERVAL_1S

GPS_DEVICE_STATUS_NO_FIX   = 1
GPS_DEVICE_STATUS_FIX      = 2
GPS_DEVICE_STATUS_DGPS_FIX = 3


class GPSDControl :

    def get_default () :
        return GPSDControl()

    get_default = get_default.__call__

    def __init__ ( self ) :
        self.method = None

    def set_properties ( self , preferred_method , preferred_interval ) :
        self.method = preferred_method
        self.interval = preferred_interval

    def start ( self ) :
        print "Starting",self

    def stop ( self ) :
        print "Stop",self

    def connect ( self , event , handler , *args ) :
        print "Connecting",self,event,handler,args

    def connect_object ( self , event , handler , *args ) :
        print "Connecting",self,event,handler,args
        #self.device.connect_object("changed", GPSObject.update , self)


class GPSDevice :

    def __init__ ( self ) :
        self.online = False
        self.status = GPS_DEVICE_STATUS_NO_FIX
        self.satellites_in_use = 0
        self.satellites_in_view = 0
        self.fix = ( None , None , 0 , None , 0.0 , -0.0 , None , 0.0 , None , "NaN" , None , "NaN" , None , "NaN" , None )
        self.satellites = ()
        self.cell_info = ()

    def connect_object ( self , signal , method , object ) :
        print "Connecting object to",self

    def stop ( self ) :
        print "Stopping",self

